package com.sencha.gxt.access.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Document;

public class Access implements EntryPoint {

  private interface AriaConfigurationImpl {
    boolean ariaIsEnabled();
  }

  private static class AriaImplFalse implements AriaConfigurationImpl {

    public boolean ariaIsEnabled() {
      return false;
    }
  }

  @SuppressWarnings("unused")
  private static class AriaImplTrue implements AriaConfigurationImpl {

    public boolean ariaIsEnabled() {
      return true;
    }
  }

  private interface FocusManagerConfigurationImpl {
    boolean focusManagerIsEnabled();
  }
  
  private static class FocusManagerImplFalse implements FocusManagerConfigurationImpl {

    public boolean focusManagerIsEnabled() {
      return false;
    }
  }
  
  @SuppressWarnings("unused")
  private static class FocusManagerImplTrue implements FocusManagerConfigurationImpl {

    public boolean focusManagerIsEnabled() {
      return true;
    }
  }
  
  
  private static AriaConfigurationImpl impl = GWT.create(AriaImplFalse.class);
  
  private static FocusManagerConfigurationImpl focusImpl = GWT.create(FocusManagerImplFalse.class);

  public static boolean ariaIsEnabled() {
    return impl.ariaIsEnabled();
  }
  

  /**
   * Returns the focus managed enabled state.
   * 
   * @return true if enabled, false otherwise
   */
  public static boolean focusManagerIsEnabled() {
    return focusImpl.focusManagerIsEnabled();
  }

  @Override
  public void onModuleLoad() {
    if (impl.ariaIsEnabled()) {
      Document.get().getBody().setAttribute("role", "application");

    }
    if (focusImpl.focusManagerIsEnabled()) {
      FocusManager.get().enable();
    }
  }

}
