package com.sencha.gxt.core.client;

/**
 * Returns the property value of the target object.
 * 
 * @param <T> the target object type
 * @param <V> the property type
 */
public interface ValueProvider<T, V> {

  /**
   * Returns the property value of the given object.
   * 
   * @param object the target object
   * @return the property value
   */
  V getValue(T object);

  /**
   * Sets the value of the given object
   * 
   * @param object
   * @param value
   */
  void setValue(T object, V value);

  /**
   * 
   * @return the path that this ValueProvider makes available, from the object,
   *         to the value
   */
  String getPath();

}
