package com.sencha.gxt.data.client.loader;

import com.google.gwt.core.client.Callback;
import com.google.gwt.storage.client.Storage;
import com.sencha.gxt.data.shared.loader.DataProxy;

/**
 * 
 * 
 * @param <C> the type of load configuration
 */
public class StorageReadProxy<C> implements DataProxy<C, String> {
  private final Storage storage;

  public StorageReadProxy(boolean session) {
    this(session ? Storage.getSessionStorageIfSupported() : Storage.getLocalStorageIfSupported());
  }

  public StorageReadProxy(Storage storage) {
    assert storage != null : "Storage may not be null";
    this.storage = storage;
  }

  @Override
  public void load(C loadConfig, Callback<String, Throwable> callback) {
    String key = getKeyFromConfig(loadConfig);
    callback.onSuccess(storage.getItem(key));
  }

  protected String getKeyFromConfig(C loadConfig) {
    return loadConfig.toString();
  }

  public void save(C saveConfig, String data) {
    String key = getKeyFromConfig(saveConfig);
    storage.setItem(key, data);
  }

}
