package com.sencha.gxt.data.client.loader;

import com.google.gwt.core.client.Callback;
import com.google.gwt.storage.client.Storage;
import com.sencha.gxt.data.client.loader.StorageWriteProxy.KeyAndValue;
import com.sencha.gxt.data.shared.loader.DataProxy;

/**
 * Proxy to push key/value string pairs into local html5 browser storage. Both
 * key and value must be populated prior to
 * 
 */
public class StorageWriteProxy implements DataProxy<KeyAndValue, Void> {
  public static class KeyAndValue {
    String key;
    String value;
  }

  private final Storage storage;

  public StorageWriteProxy(boolean session) {
    this(session ? Storage.getSessionStorageIfSupported() : Storage.getLocalStorageIfSupported());
  }

  public StorageWriteProxy(Storage storage) {
    assert storage != null : "Storage may not be null";
    this.storage = storage;
  }

  @Override
  public void load(KeyAndValue data, Callback<Void, Throwable> callback) {
    storage.setItem(data.key, data.value);
    callback.onSuccess(null);
  }

}
