package com.sencha.gxt.data.shared;

/**
 * <code>LabelProvider</code>'s are responsible for returning a label for a given object.
 * 
 * @param <T> the type of the object from
 */
public interface LabelProvider<T> {

  /**
   * Returns a label for the given object. The return value is treated as plain
   * text, and will be escaped before it is drawn.
   */
  String getLabel(T item);
}