package com.sencha.gxt.data.shared.event;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.event.shared.HasHandlers;
import com.sencha.gxt.data.shared.event.StoreClearEvent.StoreClearHandler;

/**
 * Indicates that the data in the Store has been cleared, and that corresponding
 * views should be cleared as well.
 * 
 * 
 * @param <M> the model type
 */
public final class StoreClearEvent<M> extends StoreEvent<M, StoreClearHandler<M>> {
  private static GwtEvent.Type<StoreClearHandler<?>> TYPE;

  public static GwtEvent.Type<StoreClearHandler<?>> getType() {
    if (TYPE == null) {
      TYPE = new GwtEvent.Type<StoreClearHandler<?>>();
    }
    return TYPE;
  }

  @SuppressWarnings({"rawtypes", "unchecked"})
  @Override
  public GwtEvent.Type<StoreClearHandler<M>> getAssociatedType() {
    return (GwtEvent.Type) getType();
  }

  @Override
  protected void dispatch(StoreClearHandler<M> handler) {
    handler.onClear(this);
  }

  public interface StoreClearHandler<M> extends EventHandler {
    void onClear(StoreClearEvent<M> event);
  }
  public interface HasStoreClearHandler<M> extends HasHandlers {
    HandlerRegistration addStoreClearHandler(StoreClearHandler<M> handler);
  }
}