package com.sencha.gxt.data.shared.event;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.event.shared.HasHandlers;
import com.sencha.gxt.data.shared.event.StoreDataChangeEvent.StoreDataChangeHandler;

public final class StoreDataChangeEvent<M> extends StoreEvent<M, StoreDataChangeHandler<M>> {

  private static GwtEvent.Type<StoreDataChangeHandler<?>> TYPE;

  public static GwtEvent.Type<StoreDataChangeHandler<?>> getType() {
    if (TYPE == null) {
      TYPE = new GwtEvent.Type<StoreDataChangeHandler<?>>();
    }
    return TYPE;
  }

  @SuppressWarnings({"unchecked", "rawtypes"})
  @Override
  public GwtEvent.Type<StoreDataChangeHandler<M>> getAssociatedType() {
    return (GwtEvent.Type) getType();
  }

  private M parent;

  public StoreDataChangeEvent() {

  }

  public StoreDataChangeEvent(M parent) {
    this.parent = parent;
  }

  /**
   * Returns the parent model who's children were just loaded. Parent will
   * always be null with ListStore.
   * 
   * @return the parent or null if ListStore
   */
  public M getParent() {
    return parent;
  }

  @Override
  protected void dispatch(StoreDataChangeHandler<M> handler) {
    handler.onDataChange(this);
  }

  public interface StoreDataChangeHandler<M> extends EventHandler {
    void onDataChange(StoreDataChangeEvent<M> event);
  }
  public interface HasStoreDataChangeHandlers<M> extends HasHandlers {
    HandlerRegistration addStoreDataChangeHandler(StoreDataChangeHandler<M> handler);
  }
}