package com.sencha.gxt.data.shared.event;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;
import com.sencha.gxt.data.shared.event.StoreFilterEvent.StoreFilterHandler;

/**
 * Indicates that the Store has had its filtering properties changed, resulting
 * in changes in what data is visible.
 * 
 * @param <M> The type of data in the Store
 */
public final class StoreFilterEvent<M> extends StoreEvent<M, StoreFilterHandler<M>> {
  private static GwtEvent.Type<StoreFilterHandler<?>> TYPE;

  public static Type<StoreFilterHandler<?>> getType() {
    if (TYPE == null) {
      TYPE = new GwtEvent.Type<StoreFilterHandler<?>>();
    }
    return TYPE;
  }

  @SuppressWarnings({"rawtypes", "unchecked"})
  @Override
  public GwtEvent.Type<StoreFilterHandler<M>> getAssociatedType() {
    return (GwtEvent.Type) getType();
  }

  @Override
  protected void dispatch(StoreFilterHandler<M> handler) {
    handler.onFilter(this);
  }

  public interface StoreFilterHandler<M> extends EventHandler {
    void onFilter(StoreFilterEvent<M> event);
  }
  public interface HasStoreFilterHandlers<M> extends EventHandler {
    HandlerRegistration addStoreFilterHandler(StoreFilterHandler<M> handler);
  }
}