package com.sencha.gxt.data.shared.event;

import java.util.List;

/**
 * Indicates that an element that was visible has been removed from the Store.
 * Note that non-visible elements do not get events, as most display widgets are
 * not concerned with data which has been filtered out.
 * 
 * @param <M> the model type
 */
public final class TreeStoreRemoveEvent<M> extends StoreRemoveEvent<M> {

  private M parent;
  private List<M> children;

  public TreeStoreRemoveEvent(int index, M item, M parent, List<M> children) {
    super(index, item);
    this.parent = parent;
    this.children = children;
  }

  public List<M> getChildren() {
    return children;
  }

  public M getParent() {
    return parent;
  }

}