package com.sencha.gxt.data.shared.loader;

import java.util.List;

import com.sencha.gxt.data.shared.TreeStore;

public class ChildTreeStoreBinding<M> implements LoadHandler<M, List<M>> {
  private final TreeStore<M> store;

  public ChildTreeStoreBinding(TreeStore<M> store) {
    this.store = store;
  }

  @Override
  public void onLoad(LoadEvent<M, List<M>> event) {
    M parent = event.getLoadConfig();

    store.replaceChildren(parent, event.getLoadResult());
  }
}
