package com.sencha.gxt.data.shared.loader;


import com.google.web.bindery.autobean.shared.AutoBean;
import com.google.web.bindery.autobean.shared.AutoBeanFactory;
import com.google.web.bindery.autobean.shared.Splittable;
import com.google.web.bindery.autobean.shared.impl.StringQuoter;

/**
 * A <code>DataReader</code> implementation that reads JSON data and builds it
 * into the given {@link AutoBean} type, using
 * other types from the given factory.
 * 
 * <p />
 * Subclasses can override {@link #createReturnData(Object, Object)} to control
 * what object is returned by the reader.
 * 
 * TODO We need an example here of how to build the autobean stuff
 * 
 * @param <Result> the desired return data to use from the {@link DataReader}, usually
 *          {@link ListLoadResult}
 * @param <Base> the base type of data to be read from the incoming data
 */
public class JsonReader<Result, Base> extends AbstractAutoBeanReader<Result, Base, String> {

  public JsonReader(AutoBeanFactory factory, Class<Base> rootBeanType) {
    super(factory, rootBeanType);
  }

  @Override
  protected Splittable readSplittable(Object loadConfig, String data) {
    return StringQuoter.split(data);
  }
}
