package com.sencha.gxt.data.shared.loader;

import java.util.List;

/**
 * Default implementation of the <code>ListLoadResult</code> interface.
 * 
 * @param <Data> the result data type
 */
public class ListLoadResultBean<Data> implements ListLoadResult<Data> {

  /**
   * The remote data.
   */
  protected List<Data> list;

  ListLoadResultBean() {

  }

  /**
   * Creates a new list load result.
   * 
   * @param list the data
   */
  public ListLoadResultBean(List<Data> list) {
    this.list = list;
  }

  @Override
  public List<Data> getData() {
    return list;
  }

  public void setData(List<Data> list) {
    this.list = list;
  }

}
