package com.sencha.gxt.data.shared.loader;

import com.google.gwt.core.client.Callback;
import com.google.web.bindery.requestfactory.shared.Receiver;
import com.google.web.bindery.requestfactory.shared.ServerFailure;

public abstract class RequestFactoryProxy<C, D> implements DataProxy<C, D> {
  public final void load(C loadConfig, final Callback<D, Throwable> callback) {
    load(loadConfig, new Receiver<D>() {
      public void onSuccess(D response) {
        callback.onSuccess(response);
      }
      @Override
      public void onFailure(ServerFailure error) {
        callback.onFailure(new RuntimeException(error.getMessage()));
      }
    });
  }

  public abstract void load(C loadConfig, Receiver<? super D> receiver);
}
