package com.sencha.gxt.data.shared.loader;

import java.util.List;

import com.sencha.gxt.data.shared.TreeStore;

public class SubTreeStoreBinding<M, T extends TreeStore.TreeNode<M>> implements LoadHandler<M, List<T>> {
  private final TreeStore<M> store;

  public SubTreeStoreBinding(TreeStore<M> store) {
    this.store = store;
  }

  @Override
  public void onLoad(LoadEvent<M, List<T>> event) {
    M parent = event.getLoadConfig();

    store.replaceSubTree(parent, event.getLoadResult());
  }
}
