package com.sencha.gxt.theme.base.client.container;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.CssResource;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.widget.core.client.container.BorderLayoutContainer.BorderLayoutAppearance;

public class BorderLayoutBaseAppearance implements BorderLayoutAppearance {

  public interface BorderLayoutResouces extends ClientBundle {
    @Source("BorderLayout.css")
    BorderLayoutStyle css();
  }

  public interface BorderLayoutStyle extends CssResource {
    String container();

    String child();
  }

  private final BorderLayoutResouces resources;
  private final BorderLayoutStyle style;

  public BorderLayoutBaseAppearance() {
    this(GWT.<BorderLayoutResouces> create(BorderLayoutResouces.class));
  }

  public BorderLayoutBaseAppearance(BorderLayoutResouces resources) {
    this.resources = resources;
    this.style = this.resources.css();
    this.style.ensureInjected();
  }

  @Override
  public XElement getContainerTarget(XElement parent) {
    return parent;
  }

  @Override
  public void render(SafeHtmlBuilder sb) {
    sb.appendHtmlConstant("<div class='" + style.container() + "'></div>");
  }

  @Override
  public void onInsert(Widget child) {
    child.addStyleName(style.child());
  }

  @Override
  public void onRemove(Widget child) {
    child.removeStyleName(style.child());
  }

}
