package com.sencha.gxt.theme.base.client.toolbar;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.CssResource;
import com.google.gwt.resources.client.ImageResource;
import com.google.gwt.resources.client.ImageResource.ImageOptions;
import com.google.gwt.resources.client.ImageResource.RepeatStyle;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.core.client.XTemplates;
import com.sencha.gxt.widget.core.client.toolbar.SeparatorToolItem.SeparatorToolItemAppearance;

public class SeparatorToolItemBaseAppearance implements SeparatorToolItemAppearance {

  public interface SeparatorToolItemBaseResources extends ClientBundle {

    @Source("SeparatorToolItem.css")
    SeparatorToolItemStyle css();

    @ImageOptions(repeatStyle = RepeatStyle.Vertical)
    ImageResource background();
  }
  
  public interface SeparatorToolItemStyle extends CssResource {
    
    String separator();
  }
  
  public interface Template extends XTemplates {
    @XTemplate("<div class=\"{style.separator}\"></div>")
    SafeHtml render(SeparatorToolItemStyle style);
  }
  
  protected SeparatorToolItemStyle style;
  protected Template template;
  
  public SeparatorToolItemBaseAppearance() {
    this(GWT.<SeparatorToolItemBaseResources>create(SeparatorToolItemBaseResources.class), GWT.<Template>create(Template.class));
  }
  
  public SeparatorToolItemBaseAppearance(SeparatorToolItemBaseResources resources, Template template) {
    this.style = resources.css();
    this.style.ensureInjected();
    this.template = template; 
  }
  
  @Override
  public void render(SafeHtmlBuilder sb) {
    sb.append(template.render(style));
  }

}
